CocktailsMagician/Areas/Cocktails/Models/CocktailIngredientsViewModel.cs
using System;

namespace CocktailsMagician.Areas.Cocktails.Models
{
    public class CocktailIngredientsViewModel
    {
        public Guid CocktailId { get; set; }
        public String CocktailName { get; set; }
        public Guid IngredientId { get; set; }
        public String IngredientName { get; set; }
    }
}

CocktailsMagician/Areas/Cocktails/Models/CocktailReviewViewModel.cs
using System;

namespace CocktailsMagician.Areas.Cocktails.Models
{
    public class CocktailReviewViewModel
    {
        public Guid Id { get; set; }
        public Guid CocktailId { get; set; }
        public String CocktailName { get; set; }
        public Guid UserId { get; set; }
        public String UserName { get; set; }
        public int Rating { get; set; }
        public string Comment { get; set; }
        public bool IsLiked { get; set; }
        public int NumberOfLikes { get; set; }
        public DateTime? DeletedOn { get; set; }
        public DateTime ReviewedOn { get; set; }
        //public ICollection<CocktailReviewLike> CocktailReviewLikes { get; set; }
    }
}

CocktailsMagician/Areas/Cocktails/Models/CocktailViewModel - Original.cs
using CocktailsMagician.Data.Entities;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace CocktailsMagician.Areas.Cocktails.Models
{
    public class CocktailViewModel_Original
    {
        public Guid Id { get; set; }

        [Required]
        [StringLength(50)]
        [DisplayName("Cocktail name")]
        public string Name { get; set; }

        [Required]
        [StringLength(50)]
        [DisplayName("Cocktail description")]
        public string Description { get; set; }

        [DisplayName("Unlisted")]
        public DateTime? UnlistedOn { get; set; }

        [DisplayName("Average rating")]
        public double AvgRating { get; set; }

        public ICollection<CocktailReview> CocktailReviews { get; set; }
    }
}

CocktailsMagician/Areas/Cocktails/Models/CocktailViewModel.cs
using CocktailsMagician.Areas.Ingredients.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace CocktailsMagician.Areas.Cocktails.Models
{
    public class CocktailViewModel
    {
        public Guid Id { get; set; }

        [Required]
        [StringLength(50)]
        [DisplayName("Cocktail name")]
        public string Name { get; set; }

        [Required]
        [StringLength(500)]
        [DisplayName("Cocktail description")]
        public string Description { get; set; }

        [DisplayName("Unlisted")]
        public DateTime? UnlistedOn { get; set; }

        [DisplayName("Average rating")]
        public double AvgRating { get; set; }

        public bool IsAvailableInBar { get; set; }
        public List<IngredientViewModel> Ingredients { get; set; }

        [DisplayName("Cocktail ingredients:")]
        public List<CocktailIngredientsViewModel> CocktailIngredients { get; set; }

        public List<CocktailReviewViewModel> CocktailReviews { get; set; } = new List<CocktailReviewViewModel>();
    }
}

CocktailsMagician/Areas/Cocktails/Controllers/CocktailReviewsController.cs
using System;
using System.Threading.Tasks;
using CocktailsMagician.Data.Entities;
using CocktailsMagician.Services.Contracts;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using NToastNotify;

namespace CocktailsMagician.Areas.Cocktails.Controllers
{
    [Area("Cocktails")]
    public class CocktailReviewsController : Controller
    {
        private readonly ICocktailService cocktailService;
        private readonly IIngredientService ingredientService;   
        private readonly ICocktailReviewService cocktailReviewService;
        private readonly ICocktailReviewLikeService cocktailReviewLikeService;
        private readonly UserManager<User> _userManager;
        private readonly IToastNotification _toastNotification;

        public CocktailReviewsController(ICocktailService cocktailService, IIngredientService ingredientService,
            ICocktailReviewService cocktailReviewService, UserManager<User> userManager, IToastNotification toastNotification,
            ICocktailReviewLikeService cocktailReviewLikeService)
        {
            this.cocktailService = cocktailService;
            this.ingredientService = ingredientService;
            this.cocktailReviewService = cocktailReviewService;
            this.cocktailReviewLikeService = cocktailReviewLikeService;
            this._userManager = userManager;
            this._toastNotification = toastNotification;     
        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddReview(IFormCollection form)
        {
            var review = form["Review"].ToString();
            var cocktailId = Guid.Parse(form["CocktailId"]);
            var rating = int.Parse(form["Rating"]);

            var cocktail = await cocktailService.GetCocktail(cocktailId);
            var user = await _userManager.GetUserAsync(HttpContext.User);


            await cocktailReviewService.CreateCocktailReview(cocktail.Name, user.UserName, rating, review);
            _toastNotification.AddSuccessToastMessage("Review made successfully!");

            return RedirectToAction("Details", "Cocktails", new { id = cocktailId });
        }


        [HttpPost]
        //[ValidateAntiForgeryToken]
        public async Task<IActionResult> LikeReview(Guid cocktailReviewId, bool isLiked)
        {
            var user = await _userManager.GetUserAsync(HttpContext.User);
              
            if (isLiked)
            {
                await cocktailReviewLikeService.AddCocktailReviewLike(cocktailReviewId, user.UserName);
                _toastNotification.AddSuccessToastMessage("Review liked!");
            }
            else 
            {
                await cocktailReviewLikeService.RemoveCocktailReviewLike(cocktailReviewId, user.UserName);
                _toastNotification.AddSuccessToastMessage("Review disliked!");
            }
            return Ok();
        }

        [HttpPost]
        //[ValidateAntiForgeryToken]
        public async Task<ActionResult> CheckIfPostedReview(Guid cocktailId)
        {
            var user = await _userManager.GetUserAsync(HttpContext.User);

            var hasAlreadyReviewed = await cocktailReviewService.HasAlreadyReviewedAsync(cocktailId, user.Id);
  
            return Json(hasAlreadyReviewed);       
        }
    }
}

CocktailsMagician/Areas/Cocktails/Controllers/CocktailsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using CocktailsMagician.Data;
using CocktailsMagician.Data.Entities;
using CocktailsMagician.Services.Contracts;
using CocktailsMagician.Mappers;
using CocktailsMagician.Areas.Cocktails.Models;
using CocktailsMagician.Services.DTO_s;
using X.PagedList;
using CocktailsMagician.Areas.Ingredients.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using NToastNotify;
using CocktailsMagician.Helpers;

namespace CocktailsMagician.Areas.Cocktails.Controllers
{
    [Area("Cocktails")]
    public class CocktailsController : Controller
    {
        private readonly ICocktailService cocktailService;
        private readonly IIngredientService ingredientService;
        private readonly UserManager<User> _userManager;
        private readonly ICocktailReviewService cocktailReviewService;
        private readonly IToastNotification _toastNotification;
        private readonly ICocktailReviewLikeService cocktailReviewLikeService;

        public CocktailsController(ICocktailService cocktailService, IIngredientService ingredientService,
            ICocktailReviewService cocktailReviewService, UserManager<User> userManager, IToastNotification toastNotification,
            ICocktailReviewLikeService cocktailReviewLikeService)
        {
            this.cocktailService = cocktailService;
            this.ingredientService = ingredientService;
            this.cocktailReviewService = cocktailReviewService;
            this._userManager = userManager;
            this._toastNotification = toastNotification;
            this.cocktailReviewLikeService = cocktailReviewLikeService;
        }

        // GET: Cocktails/Cocktails
        public async Task<IActionResult> Index(string sortOrder, string currentFilter, string searchString, int? page)
        {
            ViewBag.CurrentSort = sortOrder;
            ViewBag.RatingSortParm = sortOrder == "rating" ? "rating_desc" : "rating";
            ViewBag.NameSortParm = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";

            if (searchString != null)
            {
                page = 1;
            }
            else
            {
                searchString = currentFilter;
            }
            ViewBag.CurrentFilter = searchString;

            var cocktails = await cocktailService.GetAllCocktails(sortOrder, searchString);

            var cocktailsVM = cocktails
                .Select(c => c.CocktailDTOMapToVM())
                .ToList();

            int pageSize = 3;
            int pageNumber = (page ?? 1);
            ViewData["imgPath"] = ImagesPath.ImgsPath;

            return View(cocktailsVM.ToPagedList(pageNumber, pageSize));
        }

        // GET: Cocktails/Cocktails/Details/5
        public async Task<IActionResult> Details(Guid id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var cocktail = await cocktailService.GetCocktail(id);
            var cocktailIngredients = await cocktailService.ShowCocktailIngredients(id);
            var cocktailIngredientsVM = cocktailIngredients
                .Select(ci => ci.CocktailIngredientDTOMapToVM());

            if (cocktail == null)
            {
                return NotFound();
            }

            var user = await _userManager.GetUserAsync(HttpContext.User);

            ViewData["imgPath"] = ImagesPath.ImgsPath;
            ViewBag.CocktailId = cocktail.Id;

            var cocktailReviews = await cocktailReviewService.GetAllSpecificCocktailReviews(id);
            var cocktailReviewsVM = cocktailReviews.Select
                (cr => cr.CocktailReviewsDTOMapToVM())
                .ToList();

            if (user != null)
            {
                var cocktailReviewLikes = await this.cocktailReviewLikeService.GetAllSpecificCocktailReviewLikes(id);
                var userCRL = cocktailReviewLikes
                    .Where(crl => crl.UserId == user.Id)
                    .ToList();

                foreach (var userCRLike in userCRL)
                {
                    foreach (var cReview in cocktailReviewsVM)
                    {
                        if (userCRLike.UserId == user.Id && userCRLike.CocktailReviewId == cReview.Id)
                        {
                            cReview.IsLiked = userCRLike.IsLiked;
                        }
                    }
                }
            }

            foreach (var cReview in cocktailReviewsVM)
            {
                cReview.NumberOfLikes = await this.cocktailReviewLikeService.GetCocktailReviewNumberOfLikes(cReview.Id);
            }

            ViewBag.Reviews = cocktailReviewsVM;

            var ratings = cocktailReviewsVM;

            var cocktailVM = cocktail.CocktailDTOMapToVM();
            cocktailVM.CocktailIngredients = cocktailIngredientsVM.ToList();

            return View(cocktailVM);
        }



        // GET: Cocktails/Cocktails/Create
        public async Task<IActionResult> Create(CocktailViewModel cocktail)
        {
            var ingredients = await ingredientService.GetAllIngredients();
            var ingredientsVM = ingredients
                .Select(i => i.IngredientDTOMapToVM());
            cocktail.Ingredients = ingredientsVM.ToList();
            // var allIngredients = await ingredientsVM.ToListAsync();

            return View(cocktail);
        }

        // POST: Cocktails/Cocktails/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,Name,Description")] CocktailViewModel cocktail,
           List<IngredientViewModel> allIngredients)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    cocktail.Id = Guid.NewGuid();
                    var cocktailDTO = new CocktailDTO
                    {
                        Id = cocktail.Id,
                        Name = cocktail.Name,
                        Description = cocktail.Description
                    };

                    var newCocktail = await cocktailService.CreateCocktail(cocktailDTO);

                    foreach (var ingredient in allIngredients)
                    {
                        if (ingredient.isSelected)
                        {
                            var cocktailIngredientDTO = new CocktailIngredientsDTO
                            {
                                CocktailId = cocktail.Id,
                                IngredientId = ingredient.Id
                            };

                            await cocktailService.AddIngredientToCocktail(cocktailIngredientDTO);
                        }
                    }

                    _toastNotification.AddSuccessToastMessage($"Cocktail {newCocktail.Name} created successfully!");
                    return RedirectToAction(nameof(Index));
                }
                catch
                {
                    _toastNotification.AddErrorToastMessage("Cocktail cannot be created!");
                    return RedirectToAction(nameof(Index));
                }
            }
            return View(cocktail);
        }

        // GET: Cocktails/Cocktails/Edit/5
        public async Task<IActionResult> Edit(Guid id)
        {
            if (id == null)
            {
                return NotFound();
            }
            var cocktail = await cocktailService.GetCocktail(id);
            var ingredients = await ingredientService.GetAllIngredients();
            var ingredientsVM = ingredients
                .Select(i => i.IngredientDTOMapToVM());

            if (cocktail == null)
            {
                return NotFound();
            }
            var cocktailVM = cocktail.CocktailDTOMapToVM();
            cocktailVM.Ingredients = ingredientsVM.ToList();

            foreach (var ingredient in cocktailVM.Ingredients)
            {
                ingredient.isSelected = await cocktailService
                    .DoesCocktailHaveIngredient(cocktailVM.Id, ingredient.Id);
            }

            return View(cocktailVM);
        }

        // POST: Cocktails/Cocktails/Edit/5
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(Guid id, [Bind("Id,Name,Description")] CocktailViewModel cocktail,
            List<IngredientViewModel> allIngredients)
        {
            if (id != cocktail.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    await cocktailService.UpdateCocktail(cocktail.Id, cocktail.Name, cocktail.Description);

                    foreach (var ingredient in allIngredients)
                    {
                        if (ingredient.isSelected)
                        {
                            var isUnlisted = await cocktailService.IngredientIsUnlisted(cocktail.Id, ingredient.Id);

                            if (isUnlisted == true)
                            {
                                var existingCIDTO = await cocktailService.GetCocktailIngredient(cocktail.Id, ingredient.Id);
                                await cocktailService.AddIngredientToCocktail(existingCIDTO);
                            }
                            else
                            {
                                var existingCIDTO = await cocktailService.GetCocktailIngredient(cocktail.Id, ingredient.Id);

CocktailsMagician/Areas/Cocktails/Views/Cocktails/Create.cshtml
@model CocktailsMagician.Areas.Cocktails.Models.CocktailViewModel

@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<h4>Cocktail</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            @{
            await Html.RenderPartialAsync("_Partial_CI", Model.Ingredients);
            }
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CocktailsMagician/Areas/Cocktails/Views/Cocktails/Delete.cshtml
@model CocktailsMagician.Areas.Cocktails.Models.CocktailViewModel
@{
    ViewData["Title"] = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

    <center>
        <h3>Are you sure you want to delete @Model.Name?</h3>
        <div>
            <hr />
            <dl class="row">
                <dt class="col-sm-2">
                    @Html.DisplayNameFor(model => model.Name)
                </dt>
                <dd class="col-sm-10">
                    @Html.DisplayFor(model => model.Name)
                </dd>
                <dt class="col-sm-2">
                    @Html.DisplayNameFor(model => model.Description)
                </dt>
                <dd class="col-sm-10">
                    @Html.DisplayFor(model => model.Description)
                </dd>
                <dt class="col-sm-2">
                    @Html.DisplayNameFor(model => model.AvgRating)
                </dt>
                <dd class="col-sm-10">
                    @Html.DisplayFor(model => model.AvgRating)
                </dd>
            </dl>

            <form asp-action="Delete">
                <input type="hidden" asp-for="Id" />
                <input type="submit" value="Delete" class="btn btn-danger" /> |
                <a asp-action="Index" class="btn-dark">Back to List</a>
            </form>
        </div>
    </center>

CocktailsMagician/Areas/Cocktails/Views/Cocktails/Edit.cshtml
@model CocktailsMagician.Areas.Cocktails.Models.CocktailViewModel

@{
    ViewData["Title"] = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}



<h4>@Model.Name</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="Id" />
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            @{
            await Html.RenderPartialAsync("_Partial_CI", Model.Ingredients);
            }
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CocktailsMagician/Areas/Cocktails/Views/Cocktails/Index.cshtml
@model X.PagedList.IPagedList<CocktailsMagician.Areas.Cocktails.Models.CocktailViewModel>
@using X.PagedList.Mvc.Core


@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<head>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
        .fa-star {
            color: #F7F7F7;
        }

        .checked {
            color: #04D420;
        }
        
    </style>
</head>


<center> <h1>Cocktails</h1> </center>

<center>
    @using (Html.BeginForm())
    {
        <p>
            @Html.TextBox("SearchString")
            <input type="submit" class="btn-outline-success" value="Search" />
        </p>
    }
</center>
<br />
<br />

@foreach (var cocktail in Model)
{

    <div class="container">
        <div class="row" style="background-color: #DFDFDF">
            <div class="col-sm-4">
                <img src="@($"{@ViewData["imgPath"]}{cocktail.Id}.jpg")" width="250" ; height:auto onerror="this.src='/Images/cocktail.jpg';" />
            </div>
            <div class="col-sm-8">
                <div class="row">
                    <div class="col-sm-12">
                        <h3>
                            <a asp-action="Details" asp-route-id="@cocktail.Id" style="color:#4F5D75">@cocktail.Name</a>
                        </h3>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12" style="font-family: 'Roboto', sans-serif;">
                        @cocktail.Description
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        @if (cocktail.AvgRating == 0)
                        {
                            <p class="text-secondary">Not rated</p>
                        }
                        else
                        {
                            @for (int i = 0; i < (int)cocktail.AvgRating; i++)
                            {
                                <span class="fa fa-star checked"></span>
                            }
                            @for (int i = (int)cocktail.AvgRating; i < 5; i++)
                            {
                                <span class="fa fa-star"></span>
                            }
                        }
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        @String.Join(", ", cocktail.CocktailIngredients.Select(ci => ci.IngredientName).ToArray())                      
                    </div>
                </div>
            </div>
        </div>
    </div>
    <br />
}



<center>
    Page @(Model.PageCount < Model.PageNumber ? 0 : Model.PageNumber) of @Model.PageCount

    @Html.PagedListPager(Model, page => Url.Action("Index",
        new { page, sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter }))
</center>

CocktailsMagician/Areas/Cocktails/Views/Cocktails/_BarsWithCocktailsDatabale.cshtml
@model Guid
@{
    ViewData["Title"] = "_BarsDataTable";
}
<table id="bars-table">
    <thead>
        <tr>
            <th>Name</th>
            @*<th>Description</th>*@
            <th>Avg Rating</th>
        </tr>
    </thead>
    <tbody>
    </tbody>
</table>


<link href="~/DataTables/datatables.css" rel="stylesheet" type="text/css" />
<link href="~/DataTables/Buttons-1.6.2/css/buttons.dataTables.css" rel="stylesheet" />
<script src="~/DataTables/datatables.js" type="text/javascript" charset="utf8"></script>

<script>


    $(document).ready(function () {
        debugger;
            $('#bars-table').DataTable
                ({
                    "serverSide": true,
                    "destroy": true,
                    "ordering": true,
                    "processing": true,
                    "paging": true,
                    "pageLength": 5,
                    "lengthMenu": [5, 10, 25, 50, 100],
                    "pagingType": "simple_numbers",
                    "ajax": {
                        "url": "@Url.Action("ListBarsWithCocktail", "Bars", new { area = "Bars", id = Model})",
                        "type": "POST",
                        "dataType": "json",
                    },
                    drawCallback: function (settings) {
                        var response = settings.json;
                        console.log(response);

                    },
                    "columns": [
                        { "data": "name", "name": "Name", "autoWidth": true, "orderable": true, },
                        //{ "data": "description", "name": "Description", "autoWidth": true, "orderable": false, },
                        { "data": "avgRating", "name": "AvgRating", "autoWidth": true, "orderable": true, },

                    ]
                });
        });
</script>

CocktailsMagician/Areas/Cocktails/Views/Cocktails/_CommentRating.cshtml
<dl class="dl-horizontal">
    @*<dt>
        Review
    </dt>*@

    @*<dd>*@
        <div class="commentBox">
            @using (Html.BeginForm("AddReview", "CocktailReviews", FormMethod.Post, new { onsubmit = "return SubmitComment()" }))
            {
                @Html.AntiForgeryToken()
                <div class="form-horizontal">
                    <div class="form-group">
                        <label class="col-md-4 control-label">
                            Your rating <span style="font-weight:normal;"></span>
                        </label>
                        <div id ="stars" class="col-md-7">
                            <div onmouseout="CRateSelected()">
                                <span class="starFade" id="Rate1" onclick="CRate(1)" onmouseover="CRateOver(1)"
                                      onmouseout="CRateOut(1)"></span><span class="starFade" id="Rate2" onclick="CRate(2)"
                                                                            onmouseover="CRateOver(2)" onmouseout="CRateOut(2)">
                                </span><span class="starFade" id="Rate3" onclick="CRate(3)"
                                             onmouseover="CRateOver(3)" onmouseout="CRateOut(3)"></span>
                                <span class="starFade" id="Rate4" onclick="CRate(4)" onmouseover="CRateOver(4)" onmouseout="CRateOut(4)"></span><span class="starFade" id="Rate5" onclick="CRate(5)" onmouseover="CRateOver(5)" onmouseout="CRateOut(5)"></span>
                            </div>
                        </div>                   
                    </div>
                    <div class="form-group">
                        <div class="col-md-12">
                            <textarea name="Review" id="Review" required rows="5" style="width:100%;" class="form-control"></textarea>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-12">
                            <input type="hidden" name="CocktailId" value="@ViewBag.CocktailId" />
                            <input type="hidden" name="Rating" id="Rating" value="0" />
                            <input type="submit" id="btnRegister" name="btnRegister" value="Submit Comment" class="btn btn-warning" />
                        </div>
                    </div>
                </div>
            }
        </div>
    @*</dd>*@

</dl>
<script>
    function SubmitComment() {
        if ($("#Rating").val() == "0") {
            alert("Please rate this service provider.");
            return false;
        }
        else {
            return true;
        }
    }

    function CRate(r) {
        $("#Rating").val(r);
        for (var i = 1; i <= r; i++) {
            $("#Rate" + i).attr('class', 'starGlow');
        }
        // unselect remaining
        for (var i = r + 1; i <= 5; i++) {
            $("#Rate" + i).attr('class', 'starFade');
        }
    }

    function CRateOver(r) {
        for (var i = 1; i <= r; i++) {
            $("#Rate" + i).attr('class', 'starGlow');
        }
    }

    function CRateOut(r) {
        for (var i = 1; i <= r; i++) {
            $("#Rate" + i).attr('class', 'starFade');
        }
    }

    function CRateSelected() {
        var setRating = $("#Rating").val();
        for (var i = 1; i <= setRating; i++) {
            $("#Rate" + i).attr('class', 'starGlow');
        }
    }

   

</script>

<style>
    .commentBox {
    background-color: #efefef;
    padding: 10px;
    border-radius: 10px;
}

.starFade {
    background-image: url('/Images/StarFade.gif');
    min-width: 30px;
    min-height: 30px;
    display: inline-block;
    cursor: pointer;
}

.starFadeN {
    background-image: url('/Images/StarFade.gif');
    min-width: 30px;
    min-height: 30px;
    display: inline-block;
}

.starGlow {
    background-image: url('/Images/StarGlow.gif');
    min-width: 30px;
    min-height: 30px;
    display: inline-block;
    cursor: pointer;
}

.starGlowN {
    background-image: url('/Images/StarGlow.gif');
    min-width: 30px;
    min-height: 30px;
    display: inline-block;
}
</style>

CocktailsMagician/Areas/Cocktails/Views/Cocktails/_ListCI.cshtml
@model IList<CocktailsMagician.Areas.Cocktails.Models.CocktailIngredientsViewModel>

@String.Join(", ", Model.Select(p => p.IngredientName).ToArray())

CocktailsMagician/Areas/Cocktails/Views/Cocktails/_Partial_CI.cshtml
@model IList<CocktailsMagician.Areas.Ingredients.Models.IngredientViewModel>


<p> Choose cocktail ingredients: </p>

@for (var i = 0; i < Model.Count; i++)
{

    <td>
        <input type="hidden" asp-for="@Model[i].Id" readonly />

    </td>
    <td>
        <input asp-for="@Model[i].Name" readonly />
    </td>
    <td>
        <input asp-for="@Model[i].isSelected" class="form-check-input" />
    </td>
    <br />
}